package com.luxoft.university.api.models;

import java.io.Serializable;
import java.util.*;

/**
 * A leaf of tree that is used in University App. 
 * Class also provides methods for GUI support 
 * (like updateState() method - for easy updating of object's state)
 */
public class PersonNode extends BaseNode implements Serializable{
	private static final long serialVersionUID = 1L;
	private String id;
	private String name;
	private GroupNode parent;
	private String address;
	private String city;
	private Integer result;
	private String photo;

	/**
	 * Public constructor. Accepts and sets fields of Object. 
	 * Except for id. Id is generated by UUID.randomUUID() method  
	 * 
	 * @param name - name of PersonNode
	 * @param parent - parent of PersonNode
	 * @param address - address of PersonNode
	 * @param city - city of PersonNode
	 * @param result - result (mark) of PersonNode
	 * @param photo - path to picture of PersonNode
	 */
	public PersonNode(String name, GroupNode parent, String address, String city, Integer result, String photo) {
		this.id = UUID.randomUUID().toString();
		this.name = name;
		this.parent = parent;
		this.address = address;
		this.city = city;
		this.result = result;
		this.photo = photo;
	}

	@Override
	public String getId() {
		return id;
	}
	
	@Override
	public String getName() {
		return name;
	}
	
	@Override
	public GroupNode getParent() {
		return parent;
	}
	
	@Override
	public String toString() {
		return "PersonNode [name=" + name 
				+ ", parent.name=" + parent.getName() 
				+ ", address=" + address + ", city="
				+ city + ", result=" 
				+ result + ", photo=" 
				+ photo + "]";
	}
	
	@Override
	protected void setParent(GroupNode parent) {
		this.parent = parent;
	}
	
	/**
	 * Public getter
	 * 
	 * @return - value of address field
	 */
	public String getAddress() {
		return address;
	}

	/**
	 * Public getter
	 * 
	 * @return - value of city field
	 */
	public String getCity() {
		return city;
	}

	/**
	 * Public getter
	 * 
	 * @return - value of result field
	 */
	public Integer getResult() {
		return result;
	}
	
	/**
	 * Public getter
	 * 
	 * @return - value of photo field (a path to file with photo)
	 */
	public String getPhoto() {
		return photo;
	}

	/**
	 * Method for updating state of current object
	 * 
	 * @param name - name to be set
	 * @param parentName - name of parent to be set
	 * @param address - address to be set
	 * @param city - city to be set
	 * @param result - result(mark) to be set
	 * @param photo - path to photo to be set
	 */
	public void udateState(String name, String parentName, String address, String city, Integer result, String photo) {
		this.name = name;
		this.address = address;
		this.city = city;
		this.result = result;
		this.photo = photo;
		updateParent(parentName);
	}
	
	@Override
	public int hashCode() {
		return Objects.hash(address, city, name, parent, photo, result);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PersonNode other = (PersonNode) obj;
		return Objects.equals(address, other.address) && Objects.equals(city, other.city)
				&& Objects.equals(name, other.name) && Objects.equals(parent, other.parent)
				&& Objects.equals(photo, other.photo) && Objects.equals(result, other.result);
	}
}